#pragma once

#include <memory>
#include <QList>
#include <libtoken.h>
#include "libsyntax.h"

namespace ast_basic {
    // ﷨ ================================================================================================
    /**
     * @brief ﷨Ͻڵ/ʽڵ
     */
    class ExprInst {
    public:
        virtual ~ExprInst() = default;

        /**
         * @brief ȡʽĽ
         * @return
         */
        virtual std::shared_ptr<const lib_syntax::ExprRule> definedRule() const = 0;
        //=====================================================
        /**
         * ȡ﷨ڵԴļ·.
         * 
         * \return ļ·
         */
        virtual QString filePath() const = 0;
        /**
         * ȡ﷨ڵtoken.
         * 
         * \return token
         */
        virtual QList<std::shared_ptr<const lib_token::IToken>> tokens() const = 0;
        /**
         * ﷨Token.
         * 
         * \param list
         */
        virtual void tokensReset(const QList<std::shared_ptr<const lib_token::IToken>> &list) = 0;
        /**
         * Уʽڲtokenʵ.
         * 
         * \param token_inst ʵ
         */
        virtual void addToken(std::shared_ptr<const lib_token::IToken> token_inst) = 0;
        //=====================================================
        /**
         * @brief ӱʽ
         * @return
         */
        virtual QList<std::shared_ptr<const ExprInst>> children() const = 0;
        /**
         * @brief ӱʽ.
         * 
         * \param inst ӱʽʵ
         */
        virtual void addChild(std::shared_ptr<const ExprInst> inst) = 0;
    };


    // ﷨ ==========================================================================================
    /**
     * @brief ʽڵ
     */
    class LIBSYNTAX_EXPORT ExpressionElement : public ast_basic::ExprInst, public std::enable_shared_from_this<ExpressionElement> {
    private:
        std::shared_ptr<const lib_syntax::ExprRule> _expr_rule;
        QList<std::shared_ptr<const ExprInst>> children_store;
        QList<std::shared_ptr<const lib_token::IToken>> tokens_bind;

    public:
        ExpressionElement(std::shared_ptr<const lib_syntax::ExprRule> bind);

        // ͨ Expression ̳
        std::shared_ptr<const lib_syntax::ExprRule> definedRule() const override;
        QString filePath() const override;

        QList<std::shared_ptr<const lib_token::IToken>> tokens() const override;
        void tokensReset(const QList<std::shared_ptr<const lib_token::IToken>>& list) override;
        void addToken(std::shared_ptr<const lib_token::IToken> token_inst) override;

        QList<std::shared_ptr<const ExprInst>> children() const override;
        void addChild(std::shared_ptr<const ExprInst> inst) override;
    };

    class LIBSYNTAX_EXPORT ExpressionContext : public lib_syntax::ParseContext, public std::enable_shared_from_this<ExpressionContext> {
    private:
        QList<std::shared_ptr<const lib_syntax::BaseRule>> rule_stack;
        QList<std::shared_ptr<ExprInst>> expression_stack;
        QList<std::shared_ptr<const ast_basic::ExprInst>> document_store;
        QString current_file_path;
        QList<std::tuple<QString, int, QString>> errors_storage;

    public:
        ExpressionContext();

        virtual void setCurrentFile(const QString& path);
        virtual QString currentFile() const;

        // ͨ ParseContext ̳
        std::shared_ptr<ast_basic::ExprInst> currentInst() const override;
        void pushInst(std::shared_ptr<ast_basic::ExprInst> current_inst) override;
        std::shared_ptr<ast_basic::ExprInst> popInst() override;

        std::shared_ptr<const lib_syntax::BaseRule> currentExpressionRule() const override;
        void pushExpressionRule(std::shared_ptr<const lib_syntax::BaseRule> inst) override;
        std::shared_ptr<const lib_syntax::BaseRule> popExpressionRule() override;
        virtual QList<std::shared_ptr<const lib_syntax::BaseRule>> currentExpressionRuleStack() const;

        virtual void appendDoc(std::shared_ptr<ast_basic::ExprInst> inst) override;
        virtual QList<std::shared_ptr<const ast_basic::ExprInst>> getDocs() const override;

        void appendParseErrors(const QString& file_path, int start, const QString& error_msg) override;
        QStringList errors() const override;
        void clearErrors(const QString& file_path, int start) override;
    };
}